# PersistentStorageArray< TYPE, SIZE > Struct Template Reference

Class for persistent storage of data. More...

`#include <newgrf_storage.h>`

Inheritance diagram for PersistentStorageArray< TYPE, SIZE >:

## Public Member Functions
| PersistentStorageArray ()
| Simply construct the array.
| ~PersistentStorageArray ()
| And free all data related to it.
void | Store (uint pos, uint32 value)
| Stores some value at a given position.
TYPE | Get (uint pos) const
| Gets the value from a given position.
void | ClearChanges (bool keep_changes)
| Clear the changes made since the last ClearChanges.
## Data Fields
TYPE | storage [SIZE]
| Memory to for the storage array.
TYPE * | prev_storage
| Memory to store "old" states so we can revert them on the performance of test cases for commands etc.

## Detailed Description

### template<typename TYPE, uint SIZE>
struct PersistentStorageArray< TYPE, SIZE >

Class for persistent storage of data.

On ClearChanges that data is either reverted or saved.

Parameters:

  | TYPE | the type of variable to store.
  | SIZE | the size of the array.

Definition at line 50 of file newgrf_storage.h.

## Member Function Documentation

template<typename TYPE, uint SIZE>

void PersistentStorageArray< TYPE, SIZE >::Store | ( | uint | pos,
|  | uint32 | value |
| ) |  |  | `[inline, virtual]`

Stores some value at a given position.

If there is no backup of the data that backup is made and then we write the data.

Parameters:

  | pos | the position to write at
  | value | the value to write

Implements BaseStorageArray.

Definition at line 73 of file newgrf_storage.h.

template<typename TYPE, uint SIZE>

TYPE PersistentStorageArray< TYPE, SIZE >::Get | ( | uint | pos | ) | const`[inline]`

Gets the value from a given position.

Parameters:

  | pos | the position to get the data from

Returns:
  the data from that position

Definition at line 100 of file newgrf_storage.h.

template<typename TYPE, uint SIZE>

void PersistentStorageArray< TYPE, SIZE >::ClearChanges | ( | bool | keep_changes | ) | `[inline, virtual]`

Clear the changes made since the last ClearChanges.

This can be done in two ways:

- saving the changes permanently
- reverting to the previous version
  Parameters:

    | keep_changes | do we save or revert the changes since the last ClearChanges?

Implements BaseStorageArray.

Definition at line 108 of file newgrf_storage.h.

The documentation for this struct was generated from the following file:

- src/newgrf_storage.h